#!/usr/bin/perl

print "Content-Type: text/html\n\n";

$input = <STDIN>;
$input =~ s/\n//;

$N = $input;
$N =~ s/^.*name=//;
$N =~ s/&.*$//;
$N =~ s/\+/ /g;
$N =~ s/%0D%0A/<br>/g;
$N =~ s/%([0-9A-F][0-9A-F])/chr(hex($1))/eg;

if ($N eq "")	# User is not logged in...
{
#	print "<html><script language='javascript'>document.location = 'login.cgi';</script></html>";
#	exit;

	$N = "guest";
}

$admin = 0;
if ($N eq "admin")
{
	$admin = 1;
}

$guest = 0;
if ($N eq "guest")
{
	$guest = 1;
}

$write = 1;

sub write_line
{
    if ($line =~ m/#ADMIN_BEGIN/)
    {
	    $write = $admin;
    }
    elsif ($line =~ m/#ADMIN_END/)
    {
	    $write = 1;
    }
    elsif ($line =~ m/#NORMAL_BEGIN/)
    {
	    $write = 1 - $guest;
    }
    elsif ($line =~ m/#NORMAL_END/)
    {
	    $write = 1;
    }
    elsif ($line =~ m/#GUEST_BEGIN/)
    {
	    $write = $guest;
    }
    elsif ($line =~ m/#GUEST_END/)
    {
	    $write = 1;
    }
    elsif ($write == 1)
    {
	    print $line;
    }
}

open FORUM, "<forum.dat";
$count = 0;

while (<FORUM>)
{
	$mid = $_;
	$subject = <FORUM>;
	$subject =~ s/\n//;
	$name = <FORUM>;
	$time = <FORUM>;
	$message = <FORUM>;

	if ($aantal{"$subject"} > 0)
	{
		$aantal{"$subject"} ++;
	}
	else
	{
		$aantal{"$subject"} = 1;
		$keys[$count++] = $subject;
	}

	if ($firstm{"$subject"} > $time || $firstm{"$subject"}==0)
	{
		$firstm{"$subject"} = $time;
	}
	if ($lastm{"$subject"} < $time)
	{
		$lastm{"$subject"} = $time;
	}
}

close FORUM;

$stop = "no";

open PAGE, "<forumlist.html";
for (; !($line =~ m/#SUBJECT_BEGIN/); $line = <PAGE>)
{
	$line =~ s/#NAME/$N/;
	write_line;
}
close PAGE;

for ($i=0; $i<$count; $i++)
{
	open PAGE, "<forumlist.html";
	$line = "";
	for (; !($line =~ m/#SUBJECT_BEGIN/); $line = <PAGE>) { }
	$line = <PAGE>;
	for (; !($line =~ m/#SUBJECT_END/); $line = <PAGE>)
	{
		$line =~ s/#NAME/$N/;
		$line =~ s/#SUBJECT/$keys[$i]/;
		$line =~ s/#MESSAGES/$aantal{$keys[$i]}/;
		$fm = localtime ($firstm{$keys[$i]} + 9*3600);
		$line =~ s/#FIRST_MESSAGE/$fm/;
		$lm = localtime ($lastm{$keys[$i]} + 9*3600);
		$line =~ s/#LAST_MESSAGE/$lm/;
		write_line;
	}
	close PAGE;
}

open PAGE, "<forumlist.html";
$line = "";
for (; !($line =~ m/#SUBJECT_END/); $line = <PAGE>) { }

while (<PAGE>)
{
	$line = $_;
	$line =~ s/#NAME/$N/;
	write_line;
}

close PAGE;

